From 5d4e3ae028c5b913b1d9d93074cbde8c82db0ca7 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 09 2017 18:08:13 +0000
Subject: [PATCH 788/1001] Use eager loading for the hub config


---

diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index a4a8b19..65f2449 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -11,7 +11,7 @@ from .utils import get_hub, login_required
 @app.route('/<name>')
 @app.route('/<name>/')
 def hub(name):
-    hub = get_hub(name)
+    hub = get_hub(name, load_config=True)
     return flask.render_template(
         'hubs.html', hub=hub, edit=False)
 
@@ -35,7 +35,7 @@ def hub_edit(name):
 
 
 def hub_edit_get(name):
-    hub = get_hub(name)
+    hub = get_hub(name, load_config=True)
     return flask.render_template(
         'hubs.html', hub=hub, edit=True)
 
diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index 31a78d8..733a32a 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -3,23 +3,26 @@ from __future__ import unicode_literals
 import datetime
 import flask
 import functools
-import hubs.models
 import logging
 
+from hubs.models import Hub, Widget
 from six.moves.urllib import parse as urlparse
+from sqlalchemy.orm import joinedload
 from sqlalchemy.orm.exc import NoResultFound
 
 
 log = logging.getLogger(__name__)
 
 
-def get_hub(name, session=None):
+def get_hub(name, load_config=False, session=None):
     """ Utility shorthand to get a hub and 404 if not found. """
     if session is None:
         session = flask.g.db
+    query = session.query(Hub).filter(Hub.name == name)
+    if load_config:
+        query = query.options(joinedload(Hub.config))
     try:
-        return session.query(hubs.models.Hub).filter(
-            hubs.models.Hub.name == name).one()
+        return query.one()
     except NoResultFound:
         flask.abort(404)
 
@@ -33,11 +36,9 @@ def get_widget_instance(hub, idx, session=None):
     except (TypeError, ValueError):
         flask.abort(400)
     try:
-        return session.query(
-                hubs.models.Widget
-            ).join(hubs.models.Hub).filter(
-                hubs.models.Hub.name == hub,
-                hubs.models.Widget.idx == idx,
+        return session.query(Widget).join(Hub).filter(
+                Hub.name == hub,
+                Widget.idx == idx,
             ).one()
     except NoResultFound:
         flask.abort(404)
@@ -55,7 +56,7 @@ def create_widget_instance(hub, widget, position):
         widget (hubs.widgets.base.Widget): Widget to instanciate.
         position (str): either ``left`` or ``right``.
     """
-    widget_instance = hubs.models.Widget(
+    widget_instance = Widget(
         hub=hub, plugin=widget.name, index=-1,
         left=(position == 'left'))
     flask.g.db.add(widget_instance)

